﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;

namespace sampleMsBB
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

            if (!Page.IsPostBack)
            {
                
            }


            DataSet set = new DataSet();
            //Add two tables
            set.Tables.Add(BuildTable("Parent"));
            set.Tables.Add(BuildChildTable("Child"));

            //Create relations
            DataColumn parentColumn = set.Tables[0].Columns["id"];
            DataColumn childColumn = set.Tables[1].Columns["relation"];
            DataRelation relation = new DataRelation("RelationName", parentColumn, childColumn);
            set.Relations.Add(relation);

            g1.DataKeyFields = set.Tables[0].Columns["id"].ColumnName;
            foreach (DataColumn item in set.Tables[0].Columns)
            {
                BoundDataField field = new BoundDataField(true);
                field.DataFieldName = item.ColumnName;
                field.Header.Text = item.ColumnName;
                field.Key = item.ColumnName;
                g1.Columns.Add(field);
            }

            g1.DataSource = set;
            Band childBand = new Band();
            childBand.DataMember = set.Tables[1].TableName;
            childBand.DataKeyFields = set.Tables[1].Columns[1].ColumnName;
            childBand.Key = set.Tables[1].TableName;
            childBand.AutoGenerateColumns = false;
            g1.Bands.Add(childBand);

            string x = g1.Bands[0].Key;
            foreach (DataColumn item in set.Tables[1].Columns)
            {
                BoundDataField field = new BoundDataField(true);
                field.DataFieldName = item.ColumnName;
                field.Header.Text = item.ColumnName;
                field.Key = item.ColumnName;
                g1.Bands[set.Tables[1].TableName].Columns.Add(field);
            }
            g1.DataBind();


                DatePickerProvider datePickerProvider = new DatePickerProvider();
                datePickerProvider.ID = "datePicker";
                g1.EditorProviders.Add(datePickerProvider);

                EditingColumnSetting balanceAsOfDateSetting = new EditingColumnSetting();
                balanceAsOfDateSetting.ColumnKey = set.Tables[0].Columns[2].ColumnName;
                balanceAsOfDateSetting.EditorID = datePickerProvider.ID;

                g1.GridView.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(balanceAsOfDateSetting);

        }

        

        private DataTable BuildTable(string name)
        {

            System.Data.DataTable table = new DataTable(name);
            DataColumn column;
            DataRow row;

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Int32");
            column.ColumnName = "id";
            column.ReadOnly = true;
            table.Columns.Add(column);

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.String");
            column.ColumnName = "Item";
            column.AutoIncrement = false;
            column.Caption = "Item";
            column.ReadOnly = false;
            column.Unique = false;
            table.Columns.Add(column);

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.DateTime");
            column.ColumnName = "Data";
            column.AutoIncrement = false;
            column.Caption = "Data";
            column.ReadOnly = false;
            column.Unique = false;
            table.Columns.Add(column);

            DataColumn[] PrimaryKeyColumns = new DataColumn[1];
            PrimaryKeyColumns[0] = table.Columns["id"];
            table.PrimaryKey = PrimaryKeyColumns;

            for (int i = 0; i <= 20; i++)
            {
                row = table.NewRow();
                row["id"] = i;
                row["Item"] = "Item " + i;
                row["Data"] = DateTime.Now.AddDays(i);
                table.Rows.Add(row);
            }
            return table;

        }

        private DataTable BuildChildTable(string name)
        {
            System.Data.DataTable table = new DataTable(name);
            DataColumn column;
            DataRow row;

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Int32");
            column.ColumnName = "id";
            column.ReadOnly = true;
            table.Columns.Add(column);

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.String");
            column.ColumnName = "Item";
            column.AutoIncrement = false;
            column.Caption = "Item";
            column.ReadOnly = false;
            column.Unique = false;
            table.Columns.Add(column);

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.String");
            column.ColumnName = "Data";
            column.AutoIncrement = false;
            column.Caption = "Data";
            column.ReadOnly = false;
            column.Unique = false;
            table.Columns.Add(column);


            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Int32");
            column.ColumnName = "relation";
            column.AutoIncrement = false;
            column.Caption = "relation";
            column.ReadOnly = false;
            column.Unique = false;
            table.Columns.Add(column);

            DataColumn[] PrimaryKeyColumns = new DataColumn[1];
            PrimaryKeyColumns[0] = table.Columns["id"];
            table.PrimaryKey = PrimaryKeyColumns;

            for (int i = 0; i <= 100; i++)
            {
                row = table.NewRow();
                row["id"] = i;
                row["Item"] = "Item " + i;
                row["Data"] = "Data " + i;

                if ((i < 10) && (i >= 0))
                {

                    row["relation"] = 0;
                }
                else if ((i < 20) && (i >= 10))
                {
                    row["relation"] = 1;
                }
                else if ((i < 30) && (i >= 20))
                {
                    row["relation"] = 2;
                }
                else if ((i < 40) && (i >= 30))
                {
                    row["relation"] = 3;
                }
                else if ((i < 50) && (i >= 40))
                {
                }
                table.Rows.Add(row);
            }
            return table;

        }

        protected void test(object sender, EventArgs e)
        {
            Infragistics.Web.UI.GridControls.WebHierarchicalDataGrid tempGrid = g1;
            int rowCount = tempGrid.Rows.Count;
            int columnCount = tempGrid.Columns.Count;
        }

       
    }
}
